'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var qiankun = _interopDefault(require('vite-plugin-qiankun'));
var eslintPlugin = _interopDefault(require('vite-plugin-eslint'));
var tsconfigPaths = _interopDefault(require('vite-tsconfig-paths'));
var StylelintPlugin = _interopDefault(require('vite-plugin-stylelint'));
var vitePluginHtml = require('vite-plugin-html');
var react = _interopDefault(require('@vitejs/plugin-react'));
var legacy = _interopDefault(require('@vitejs/plugin-legacy'));
var typescript = _interopDefault(require('@rollup/plugin-typescript'));

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
}

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var isBuffer = function isBuffer(arg) {
  return arg instanceof Buffer;
};

var inherits_browser = createCommonjsModule(function (module) {
if (typeof Object.create === 'function') {
  // implementation from standard node.js 'util' module
  module.exports = function inherits(ctor, superCtor) {
    ctor.super_ = superCtor;
    ctor.prototype = Object.create(superCtor.prototype, {
      constructor: {
        value: ctor,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
  };
} else {
  // old school shim for old browsers
  module.exports = function inherits(ctor, superCtor) {
    ctor.super_ = superCtor;
    var TempCtor = function () {};
    TempCtor.prototype = superCtor.prototype;
    ctor.prototype = new TempCtor();
    ctor.prototype.constructor = ctor;
  };
}
});

var inherits = createCommonjsModule(function (module) {
try {
  var util$1 = util;
  if (typeof util$1.inherits !== 'function') throw '';
  module.exports = util$1.inherits;
} catch (e) {
  module.exports = inherits_browser;
}
});

var util = createCommonjsModule(function (module, exports) {
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

var formatRegExp = /%[sdj%]/g;
exports.format = function(f) {
  if (!isString(f)) {
    var objects = [];
    for (var i = 0; i < arguments.length; i++) {
      objects.push(inspect(arguments[i]));
    }
    return objects.join(' ');
  }

  var i = 1;
  var args = arguments;
  var len = args.length;
  var str = String(f).replace(formatRegExp, function(x) {
    if (x === '%%') return '%';
    if (i >= len) return x;
    switch (x) {
      case '%s': return String(args[i++]);
      case '%d': return Number(args[i++]);
      case '%j':
        try {
          return JSON.stringify(args[i++]);
        } catch (_) {
          return '[Circular]';
        }
      default:
        return x;
    }
  });
  for (var x = args[i]; i < len; x = args[++i]) {
    if (isNull(x) || !isObject(x)) {
      str += ' ' + x;
    } else {
      str += ' ' + inspect(x);
    }
  }
  return str;
};


// Mark that a method should not be used.
// Returns a modified function which warns once by default.
// If --no-deprecation is set, then it is a no-op.
exports.deprecate = function(fn, msg) {
  // Allow for deprecating things in the process of starting up.
  if (isUndefined(commonjsGlobal.process)) {
    return function() {
      return exports.deprecate(fn, msg).apply(this, arguments);
    };
  }

  if (process.noDeprecation === true) {
    return fn;
  }

  var warned = false;
  function deprecated() {
    if (!warned) {
      if (process.throwDeprecation) {
        throw new Error(msg);
      } else if (process.traceDeprecation) {
        console.trace(msg);
      } else {
        console.error(msg);
      }
      warned = true;
    }
    return fn.apply(this, arguments);
  }

  return deprecated;
};


var debugs = {};
var debugEnviron;
exports.debuglog = function(set) {
  if (isUndefined(debugEnviron))
    debugEnviron = process.env.NODE_DEBUG || '';
  set = set.toUpperCase();
  if (!debugs[set]) {
    if (new RegExp('\\b' + set + '\\b', 'i').test(debugEnviron)) {
      var pid = process.pid;
      debugs[set] = function() {
        var msg = exports.format.apply(exports, arguments);
        console.error('%s %d: %s', set, pid, msg);
      };
    } else {
      debugs[set] = function() {};
    }
  }
  return debugs[set];
};


/**
 * Echos the value of a value. Trys to print the value out
 * in the best way possible given the different types.
 *
 * @param {Object} obj The object to print out.
 * @param {Object} opts Optional options object that alters the output.
 */
/* legacy: obj, showHidden, depth, colors*/
function inspect(obj, opts) {
  // default options
  var ctx = {
    seen: [],
    stylize: stylizeNoColor
  };
  // legacy...
  if (arguments.length >= 3) ctx.depth = arguments[2];
  if (arguments.length >= 4) ctx.colors = arguments[3];
  if (isBoolean(opts)) {
    // legacy...
    ctx.showHidden = opts;
  } else if (opts) {
    // got an "options" object
    exports._extend(ctx, opts);
  }
  // set default options
  if (isUndefined(ctx.showHidden)) ctx.showHidden = false;
  if (isUndefined(ctx.depth)) ctx.depth = 2;
  if (isUndefined(ctx.colors)) ctx.colors = false;
  if (isUndefined(ctx.customInspect)) ctx.customInspect = true;
  if (ctx.colors) ctx.stylize = stylizeWithColor;
  return formatValue(ctx, obj, ctx.depth);
}
exports.inspect = inspect;


// http://en.wikipedia.org/wiki/ANSI_escape_code#graphics
inspect.colors = {
  'bold' : [1, 22],
  'italic' : [3, 23],
  'underline' : [4, 24],
  'inverse' : [7, 27],
  'white' : [37, 39],
  'grey' : [90, 39],
  'black' : [30, 39],
  'blue' : [34, 39],
  'cyan' : [36, 39],
  'green' : [32, 39],
  'magenta' : [35, 39],
  'red' : [31, 39],
  'yellow' : [33, 39]
};

// Don't use 'blue' not visible on cmd.exe
inspect.styles = {
  'special': 'cyan',
  'number': 'yellow',
  'boolean': 'yellow',
  'undefined': 'grey',
  'null': 'bold',
  'string': 'green',
  'date': 'magenta',
  // "name": intentionally not styling
  'regexp': 'red'
};


function stylizeWithColor(str, styleType) {
  var style = inspect.styles[styleType];

  if (style) {
    return '\u001b[' + inspect.colors[style][0] + 'm' + str +
           '\u001b[' + inspect.colors[style][1] + 'm';
  } else {
    return str;
  }
}


function stylizeNoColor(str, styleType) {
  return str;
}


function arrayToHash(array) {
  var hash = {};

  array.forEach(function(val, idx) {
    hash[val] = true;
  });

  return hash;
}


function formatValue(ctx, value, recurseTimes) {
  // Provide a hook for user-specified inspect functions.
  // Check that value is an object with an inspect function on it
  if (ctx.customInspect &&
      value &&
      isFunction(value.inspect) &&
      // Filter out the util module, it's inspect function is special
      value.inspect !== exports.inspect &&
      // Also filter out any prototype objects using the circular check.
      !(value.constructor && value.constructor.prototype === value)) {
    var ret = value.inspect(recurseTimes, ctx);
    if (!isString(ret)) {
      ret = formatValue(ctx, ret, recurseTimes);
    }
    return ret;
  }

  // Primitive types cannot have properties
  var primitive = formatPrimitive(ctx, value);
  if (primitive) {
    return primitive;
  }

  // Look up the keys of the object.
  var keys = Object.keys(value);
  var visibleKeys = arrayToHash(keys);

  if (ctx.showHidden) {
    keys = Object.getOwnPropertyNames(value);
  }

  // IE doesn't make error fields non-enumerable
  // http://msdn.microsoft.com/en-us/library/ie/dww52sbt(v=vs.94).aspx
  if (isError(value)
      && (keys.indexOf('message') >= 0 || keys.indexOf('description') >= 0)) {
    return formatError(value);
  }

  // Some type of object without properties can be shortcutted.
  if (keys.length === 0) {
    if (isFunction(value)) {
      var name = value.name ? ': ' + value.name : '';
      return ctx.stylize('[Function' + name + ']', 'special');
    }
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
    }
    if (isDate(value)) {
      return ctx.stylize(Date.prototype.toString.call(value), 'date');
    }
    if (isError(value)) {
      return formatError(value);
    }
  }

  var base = '', array = false, braces = ['{', '}'];

  // Make Array say that they are Array
  if (isArray(value)) {
    array = true;
    braces = ['[', ']'];
  }

  // Make functions say that they are functions
  if (isFunction(value)) {
    var n = value.name ? ': ' + value.name : '';
    base = ' [Function' + n + ']';
  }

  // Make RegExps say that they are RegExps
  if (isRegExp(value)) {
    base = ' ' + RegExp.prototype.toString.call(value);
  }

  // Make dates with properties first say the date
  if (isDate(value)) {
    base = ' ' + Date.prototype.toUTCString.call(value);
  }

  // Make error with message first say the error
  if (isError(value)) {
    base = ' ' + formatError(value);
  }

  if (keys.length === 0 && (!array || value.length == 0)) {
    return braces[0] + base + braces[1];
  }

  if (recurseTimes < 0) {
    if (isRegExp(value)) {
      return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
    } else {
      return ctx.stylize('[Object]', 'special');
    }
  }

  ctx.seen.push(value);

  var output;
  if (array) {
    output = formatArray(ctx, value, recurseTimes, visibleKeys, keys);
  } else {
    output = keys.map(function(key) {
      return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
    });
  }

  ctx.seen.pop();

  return reduceToSingleString(output, base, braces);
}


function formatPrimitive(ctx, value) {
  if (isUndefined(value))
    return ctx.stylize('undefined', 'undefined');
  if (isString(value)) {
    var simple = '\'' + JSON.stringify(value).replace(/^"|"$/g, '')
                                             .replace(/'/g, "\\'")
                                             .replace(/\\"/g, '"') + '\'';
    return ctx.stylize(simple, 'string');
  }
  if (isNumber(value))
    return ctx.stylize('' + value, 'number');
  if (isBoolean(value))
    return ctx.stylize('' + value, 'boolean');
  // For some reason typeof null is "object", so special case here.
  if (isNull(value))
    return ctx.stylize('null', 'null');
}


function formatError(value) {
  return '[' + Error.prototype.toString.call(value) + ']';
}


function formatArray(ctx, value, recurseTimes, visibleKeys, keys) {
  var output = [];
  for (var i = 0, l = value.length; i < l; ++i) {
    if (hasOwnProperty(value, String(i))) {
      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
          String(i), true));
    } else {
      output.push('');
    }
  }
  keys.forEach(function(key) {
    if (!key.match(/^\d+$/)) {
      output.push(formatProperty(ctx, value, recurseTimes, visibleKeys,
          key, true));
    }
  });
  return output;
}


function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
  var name, str, desc;
  desc = Object.getOwnPropertyDescriptor(value, key) || { value: value[key] };
  if (desc.get) {
    if (desc.set) {
      str = ctx.stylize('[Getter/Setter]', 'special');
    } else {
      str = ctx.stylize('[Getter]', 'special');
    }
  } else {
    if (desc.set) {
      str = ctx.stylize('[Setter]', 'special');
    }
  }
  if (!hasOwnProperty(visibleKeys, key)) {
    name = '[' + key + ']';
  }
  if (!str) {
    if (ctx.seen.indexOf(desc.value) < 0) {
      if (isNull(recurseTimes)) {
        str = formatValue(ctx, desc.value, null);
      } else {
        str = formatValue(ctx, desc.value, recurseTimes - 1);
      }
      if (str.indexOf('\n') > -1) {
        if (array) {
          str = str.split('\n').map(function(line) {
            return '  ' + line;
          }).join('\n').substr(2);
        } else {
          str = '\n' + str.split('\n').map(function(line) {
            return '   ' + line;
          }).join('\n');
        }
      }
    } else {
      str = ctx.stylize('[Circular]', 'special');
    }
  }
  if (isUndefined(name)) {
    if (array && key.match(/^\d+$/)) {
      return str;
    }
    name = JSON.stringify('' + key);
    if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
      name = name.substr(1, name.length - 2);
      name = ctx.stylize(name, 'name');
    } else {
      name = name.replace(/'/g, "\\'")
                 .replace(/\\"/g, '"')
                 .replace(/(^"|"$)/g, "'");
      name = ctx.stylize(name, 'string');
    }
  }

  return name + ': ' + str;
}


function reduceToSingleString(output, base, braces) {
  var length = output.reduce(function(prev, cur) {
    if (cur.indexOf('\n') >= 0) ;
    return prev + cur.replace(/\u001b\[\d\d?m/g, '').length + 1;
  }, 0);

  if (length > 60) {
    return braces[0] +
           (base === '' ? '' : base + '\n ') +
           ' ' +
           output.join(',\n  ') +
           ' ' +
           braces[1];
  }

  return braces[0] + base + ' ' + output.join(', ') + ' ' + braces[1];
}


// NOTE: These type checking functions intentionally don't use `instanceof`
// because it is fragile and can be easily faked with `Object.create()`.
function isArray(ar) {
  return Array.isArray(ar);
}
exports.isArray = isArray;

function isBoolean(arg) {
  return typeof arg === 'boolean';
}
exports.isBoolean = isBoolean;

function isNull(arg) {
  return arg === null;
}
exports.isNull = isNull;

function isNullOrUndefined(arg) {
  return arg == null;
}
exports.isNullOrUndefined = isNullOrUndefined;

function isNumber(arg) {
  return typeof arg === 'number';
}
exports.isNumber = isNumber;

function isString(arg) {
  return typeof arg === 'string';
}
exports.isString = isString;

function isSymbol(arg) {
  return typeof arg === 'symbol';
}
exports.isSymbol = isSymbol;

function isUndefined(arg) {
  return arg === void 0;
}
exports.isUndefined = isUndefined;

function isRegExp(re) {
  return isObject(re) && objectToString(re) === '[object RegExp]';
}
exports.isRegExp = isRegExp;

function isObject(arg) {
  return typeof arg === 'object' && arg !== null;
}
exports.isObject = isObject;

function isDate(d) {
  return isObject(d) && objectToString(d) === '[object Date]';
}
exports.isDate = isDate;

function isError(e) {
  return isObject(e) &&
      (objectToString(e) === '[object Error]' || e instanceof Error);
}
exports.isError = isError;

function isFunction(arg) {
  return typeof arg === 'function';
}
exports.isFunction = isFunction;

function isPrimitive(arg) {
  return arg === null ||
         typeof arg === 'boolean' ||
         typeof arg === 'number' ||
         typeof arg === 'string' ||
         typeof arg === 'symbol' ||  // ES6 symbol
         typeof arg === 'undefined';
}
exports.isPrimitive = isPrimitive;

exports.isBuffer = isBuffer;

function objectToString(o) {
  return Object.prototype.toString.call(o);
}


function pad(n) {
  return n < 10 ? '0' + n.toString(10) : n.toString(10);
}


var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep',
              'Oct', 'Nov', 'Dec'];

// 26 Feb 16:19:34
function timestamp() {
  var d = new Date();
  var time = [pad(d.getHours()),
              pad(d.getMinutes()),
              pad(d.getSeconds())].join(':');
  return [d.getDate(), months[d.getMonth()], time].join(' ');
}


// log is just a thin wrapper to console.log that prepends a timestamp
exports.log = function() {
  console.log('%s - %s', timestamp(), exports.format.apply(exports, arguments));
};


/**
 * Inherit the prototype methods from one constructor into another.
 *
 * The Function.prototype.inherits from lang.js rewritten as a standalone
 * function (not on Function.prototype). NOTE: If this file is to be loaded
 * during bootstrapping this function needs to be rewritten using some native
 * functions as prototype setup using normal JavaScript does not work as
 * expected during bootstrapping (see mirror.js in r114903).
 *
 * @param {function} ctor Constructor function which needs to inherit the
 *     prototype.
 * @param {function} superCtor Constructor function to inherit prototype from.
 */
exports.inherits = inherits;

exports._extend = function(origin, add) {
  // Don't do anything if add isn't an object
  if (!add || !isObject(add)) return origin;

  var keys = Object.keys(add);
  var i = keys.length;
  while (i--) {
    origin[keys[i]] = add[keys[i]];
  }
  return origin;
};

function hasOwnProperty(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
}
});
var util_1 = util.format;
var util_2 = util.deprecate;
var util_3 = util.debuglog;
var util_4 = util.inspect;
var util_5 = util.isArray;
var util_6 = util.isBoolean;
var util_7 = util.isNull;
var util_8 = util.isNullOrUndefined;
var util_9 = util.isNumber;
var util_10 = util.isString;
var util_11 = util.isSymbol;
var util_12 = util.isUndefined;
var util_13 = util.isRegExp;
var util_14 = util.isObject;
var util_15 = util.isDate;
var util_16 = util.isError;
var util_17 = util.isFunction;
var util_18 = util.isPrimitive;
var util_19 = util.isBuffer;
var util_20 = util.log;
var util_21 = util.inherits;
var util_22 = util._extend;

var path = createCommonjsModule(function (module) {


var isWindows = process.platform === 'win32';



// resolves . and .. elements in a path array with directory names there
// must be no slashes or device names (c:\) in the array
// (so also no leading and trailing slashes - it does not distinguish
// relative and absolute paths)
function normalizeArray(parts, allowAboveRoot) {
  var res = [];
  for (var i = 0; i < parts.length; i++) {
    var p = parts[i];

    // ignore empty parts
    if (!p || p === '.')
      continue;

    if (p === '..') {
      if (res.length && res[res.length - 1] !== '..') {
        res.pop();
      } else if (allowAboveRoot) {
        res.push('..');
      }
    } else {
      res.push(p);
    }
  }

  return res;
}

// returns an array with empty elements removed from either end of the input
// array or the original array if no elements need to be removed
function trimArray(arr) {
  var lastIndex = arr.length - 1;
  var start = 0;
  for (; start <= lastIndex; start++) {
    if (arr[start])
      break;
  }

  var end = lastIndex;
  for (; end >= 0; end--) {
    if (arr[end])
      break;
  }

  if (start === 0 && end === lastIndex)
    return arr;
  if (start > end)
    return [];
  return arr.slice(start, end + 1);
}

// Regex to split a windows path into three parts: [*, device, slash,
// tail] windows-only
var splitDeviceRe =
    /^([a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/]+[^\\\/]+)?([\\\/])?([\s\S]*?)$/;

// Regex to split the tail part of the above into [*, dir, basename, ext]
var splitTailRe =
    /^([\s\S]*?)((?:\.{1,2}|[^\\\/]+?|)(\.[^.\/\\]*|))(?:[\\\/]*)$/;

var win32 = {};

// Function to split a filename into [root, dir, basename, ext]
function win32SplitPath(filename) {
  // Separate device+slash from tail
  var result = splitDeviceRe.exec(filename),
      device = (result[1] || '') + (result[2] || ''),
      tail = result[3] || '';
  // Split the tail into dir, basename and extension
  var result2 = splitTailRe.exec(tail),
      dir = result2[1],
      basename = result2[2],
      ext = result2[3];
  return [device, dir, basename, ext];
}

function win32StatPath(path) {
  var result = splitDeviceRe.exec(path),
      device = result[1] || '',
      isUnc = !!device && device[1] !== ':';
  return {
    device: device,
    isUnc: isUnc,
    isAbsolute: isUnc || !!result[2], // UNC paths are always absolute
    tail: result[3]
  };
}

function normalizeUNCRoot(device) {
  return '\\\\' + device.replace(/^[\\\/]+/, '').replace(/[\\\/]+/g, '\\');
}

// path.resolve([from ...], to)
win32.resolve = function() {
  var resolvedDevice = '',
      resolvedTail = '',
      resolvedAbsolute = false;

  for (var i = arguments.length - 1; i >= -1; i--) {
    var path;
    if (i >= 0) {
      path = arguments[i];
    } else if (!resolvedDevice) {
      path = process.cwd();
    } else {
      // Windows has the concept of drive-specific current working
      // directories. If we've resolved a drive letter but not yet an
      // absolute path, get cwd for that drive. We're sure the device is not
      // an unc path at this points, because unc paths are always absolute.
      path = process.env['=' + resolvedDevice];
      // Verify that a drive-local cwd was found and that it actually points
      // to our drive. If not, default to the drive's root.
      if (!path || path.substr(0, 3).toLowerCase() !==
          resolvedDevice.toLowerCase() + '\\') {
        path = resolvedDevice + '\\';
      }
    }

    // Skip empty and invalid entries
    if (!util.isString(path)) {
      throw new TypeError('Arguments to path.resolve must be strings');
    } else if (!path) {
      continue;
    }

    var result = win32StatPath(path),
        device = result.device,
        isUnc = result.isUnc,
        isAbsolute = result.isAbsolute,
        tail = result.tail;

    if (device &&
        resolvedDevice &&
        device.toLowerCase() !== resolvedDevice.toLowerCase()) {
      // This path points to another device so it is not applicable
      continue;
    }

    if (!resolvedDevice) {
      resolvedDevice = device;
    }
    if (!resolvedAbsolute) {
      resolvedTail = tail + '\\' + resolvedTail;
      resolvedAbsolute = isAbsolute;
    }

    if (resolvedDevice && resolvedAbsolute) {
      break;
    }
  }

  // Convert slashes to backslashes when `resolvedDevice` points to an UNC
  // root. Also squash multiple slashes into a single one where appropriate.
  if (isUnc) {
    resolvedDevice = normalizeUNCRoot(resolvedDevice);
  }

  // At this point the path should be resolved to a full absolute path,
  // but handle relative paths to be safe (might happen when process.cwd()
  // fails)

  // Normalize the tail path
  resolvedTail = normalizeArray(resolvedTail.split(/[\\\/]+/),
                                !resolvedAbsolute).join('\\');

  return (resolvedDevice + (resolvedAbsolute ? '\\' : '') + resolvedTail) ||
         '.';
};


win32.normalize = function(path) {
  var result = win32StatPath(path),
      device = result.device,
      isUnc = result.isUnc,
      isAbsolute = result.isAbsolute,
      tail = result.tail,
      trailingSlash = /[\\\/]$/.test(tail);

  // Normalize the tail path
  tail = normalizeArray(tail.split(/[\\\/]+/), !isAbsolute).join('\\');

  if (!tail && !isAbsolute) {
    tail = '.';
  }
  if (tail && trailingSlash) {
    tail += '\\';
  }

  // Convert slashes to backslashes when `device` points to an UNC root.
  // Also squash multiple slashes into a single one where appropriate.
  if (isUnc) {
    device = normalizeUNCRoot(device);
  }

  return device + (isAbsolute ? '\\' : '') + tail;
};


win32.isAbsolute = function(path) {
  return win32StatPath(path).isAbsolute;
};

win32.join = function() {
  var paths = [];
  for (var i = 0; i < arguments.length; i++) {
    var arg = arguments[i];
    if (!util.isString(arg)) {
      throw new TypeError('Arguments to path.join must be strings');
    }
    if (arg) {
      paths.push(arg);
    }
  }

  var joined = paths.join('\\');

  // Make sure that the joined path doesn't start with two slashes, because
  // normalize() will mistake it for an UNC path then.
  //
  // This step is skipped when it is very clear that the user actually
  // intended to point at an UNC path. This is assumed when the first
  // non-empty string arguments starts with exactly two slashes followed by
  // at least one more non-slash character.
  //
  // Note that for normalize() to treat a path as an UNC path it needs to
  // have at least 2 components, so we don't filter for that here.
  // This means that the user can use join to construct UNC paths from
  // a server name and a share name; for example:
  //   path.join('//server', 'share') -> '\\\\server\\share\')
  if (!/^[\\\/]{2}[^\\\/]/.test(paths[0])) {
    joined = joined.replace(/^[\\\/]{2,}/, '\\');
  }

  return win32.normalize(joined);
};


// path.relative(from, to)
// it will solve the relative path from 'from' to 'to', for instance:
// from = 'C:\\orandea\\test\\aaa'
// to = 'C:\\orandea\\impl\\bbb'
// The output of the function should be: '..\\..\\impl\\bbb'
win32.relative = function(from, to) {
  from = win32.resolve(from);
  to = win32.resolve(to);

  // windows is not case sensitive
  var lowerFrom = from.toLowerCase();
  var lowerTo = to.toLowerCase();

  var toParts = trimArray(to.split('\\'));

  var lowerFromParts = trimArray(lowerFrom.split('\\'));
  var lowerToParts = trimArray(lowerTo.split('\\'));

  var length = Math.min(lowerFromParts.length, lowerToParts.length);
  var samePartsLength = length;
  for (var i = 0; i < length; i++) {
    if (lowerFromParts[i] !== lowerToParts[i]) {
      samePartsLength = i;
      break;
    }
  }

  if (samePartsLength == 0) {
    return to;
  }

  var outputParts = [];
  for (var i = samePartsLength; i < lowerFromParts.length; i++) {
    outputParts.push('..');
  }

  outputParts = outputParts.concat(toParts.slice(samePartsLength));

  return outputParts.join('\\');
};


win32._makeLong = function(path) {
  // Note: this will *probably* throw somewhere.
  if (!util.isString(path))
    return path;

  if (!path) {
    return '';
  }

  var resolvedPath = win32.resolve(path);

  if (/^[a-zA-Z]\:\\/.test(resolvedPath)) {
    // path is local filesystem path, which needs to be converted
    // to long UNC path.
    return '\\\\?\\' + resolvedPath;
  } else if (/^\\\\[^?.]/.test(resolvedPath)) {
    // path is network UNC path, which needs to be converted
    // to long UNC path.
    return '\\\\?\\UNC\\' + resolvedPath.substring(2);
  }

  return path;
};


win32.dirname = function(path) {
  var result = win32SplitPath(path),
      root = result[0],
      dir = result[1];

  if (!root && !dir) {
    // No dirname whatsoever
    return '.';
  }

  if (dir) {
    // It has a dirname, strip trailing slash
    dir = dir.substr(0, dir.length - 1);
  }

  return root + dir;
};


win32.basename = function(path, ext) {
  var f = win32SplitPath(path)[2];
  // TODO: make this comparison case-insensitive on windows?
  if (ext && f.substr(-1 * ext.length) === ext) {
    f = f.substr(0, f.length - ext.length);
  }
  return f;
};


win32.extname = function(path) {
  return win32SplitPath(path)[3];
};


win32.format = function(pathObject) {
  if (!util.isObject(pathObject)) {
    throw new TypeError(
        "Parameter 'pathObject' must be an object, not " + typeof pathObject
    );
  }

  var root = pathObject.root || '';

  if (!util.isString(root)) {
    throw new TypeError(
        "'pathObject.root' must be a string or undefined, not " +
        typeof pathObject.root
    );
  }

  var dir = pathObject.dir;
  var base = pathObject.base || '';
  if (!dir) {
    return base;
  }
  if (dir[dir.length - 1] === win32.sep) {
    return dir + base;
  }
  return dir + win32.sep + base;
};


win32.parse = function(pathString) {
  if (!util.isString(pathString)) {
    throw new TypeError(
        "Parameter 'pathString' must be a string, not " + typeof pathString
    );
  }
  var allParts = win32SplitPath(pathString);
  if (!allParts || allParts.length !== 4) {
    throw new TypeError("Invalid path '" + pathString + "'");
  }
  return {
    root: allParts[0],
    dir: allParts[0] + allParts[1].slice(0, -1),
    base: allParts[2],
    ext: allParts[3],
    name: allParts[2].slice(0, allParts[2].length - allParts[3].length)
  };
};


win32.sep = '\\';
win32.delimiter = ';';


// Split a filename into [root, dir, basename, ext], unix version
// 'root' is just a slash, or nothing.
var splitPathRe =
    /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
var posix = {};


function posixSplitPath(filename) {
  return splitPathRe.exec(filename).slice(1);
}


// path.resolve([from ...], to)
// posix version
posix.resolve = function() {
  var resolvedPath = '',
      resolvedAbsolute = false;

  for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
    var path = (i >= 0) ? arguments[i] : process.cwd();

    // Skip empty and invalid entries
    if (!util.isString(path)) {
      throw new TypeError('Arguments to path.resolve must be strings');
    } else if (!path) {
      continue;
    }

    resolvedPath = path + '/' + resolvedPath;
    resolvedAbsolute = path[0] === '/';
  }

  // At this point the path should be resolved to a full absolute path, but
  // handle relative paths to be safe (might happen when process.cwd() fails)

  // Normalize the path
  resolvedPath = normalizeArray(resolvedPath.split('/'),
                                !resolvedAbsolute).join('/');

  return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
};

// path.normalize(path)
// posix version
posix.normalize = function(path) {
  var isAbsolute = posix.isAbsolute(path),
      trailingSlash = path && path[path.length - 1] === '/';

  // Normalize the path
  path = normalizeArray(path.split('/'), !isAbsolute).join('/');

  if (!path && !isAbsolute) {
    path = '.';
  }
  if (path && trailingSlash) {
    path += '/';
  }

  return (isAbsolute ? '/' : '') + path;
};

// posix version
posix.isAbsolute = function(path) {
  return path.charAt(0) === '/';
};

// posix version
posix.join = function() {
  var path = '';
  for (var i = 0; i < arguments.length; i++) {
    var segment = arguments[i];
    if (!util.isString(segment)) {
      throw new TypeError('Arguments to path.join must be strings');
    }
    if (segment) {
      if (!path) {
        path += segment;
      } else {
        path += '/' + segment;
      }
    }
  }
  return posix.normalize(path);
};


// path.relative(from, to)
// posix version
posix.relative = function(from, to) {
  from = posix.resolve(from).substr(1);
  to = posix.resolve(to).substr(1);

  var fromParts = trimArray(from.split('/'));
  var toParts = trimArray(to.split('/'));

  var length = Math.min(fromParts.length, toParts.length);
  var samePartsLength = length;
  for (var i = 0; i < length; i++) {
    if (fromParts[i] !== toParts[i]) {
      samePartsLength = i;
      break;
    }
  }

  var outputParts = [];
  for (var i = samePartsLength; i < fromParts.length; i++) {
    outputParts.push('..');
  }

  outputParts = outputParts.concat(toParts.slice(samePartsLength));

  return outputParts.join('/');
};


posix._makeLong = function(path) {
  return path;
};


posix.dirname = function(path) {
  var result = posixSplitPath(path),
      root = result[0],
      dir = result[1];

  if (!root && !dir) {
    // No dirname whatsoever
    return '.';
  }

  if (dir) {
    // It has a dirname, strip trailing slash
    dir = dir.substr(0, dir.length - 1);
  }

  return root + dir;
};


posix.basename = function(path, ext) {
  var f = posixSplitPath(path)[2];
  // TODO: make this comparison case-insensitive on windows?
  if (ext && f.substr(-1 * ext.length) === ext) {
    f = f.substr(0, f.length - ext.length);
  }
  return f;
};


posix.extname = function(path) {
  return posixSplitPath(path)[3];
};


posix.format = function(pathObject) {
  if (!util.isObject(pathObject)) {
    throw new TypeError(
        "Parameter 'pathObject' must be an object, not " + typeof pathObject
    );
  }

  var root = pathObject.root || '';

  if (!util.isString(root)) {
    throw new TypeError(
        "'pathObject.root' must be a string or undefined, not " +
        typeof pathObject.root
    );
  }

  var dir = pathObject.dir ? pathObject.dir + posix.sep : '';
  var base = pathObject.base || '';
  return dir + base;
};


posix.parse = function(pathString) {
  if (!util.isString(pathString)) {
    throw new TypeError(
        "Parameter 'pathString' must be a string, not " + typeof pathString
    );
  }
  var allParts = posixSplitPath(pathString);
  if (!allParts || allParts.length !== 4) {
    throw new TypeError("Invalid path '" + pathString + "'");
  }
  allParts[1] = allParts[1] || '';
  allParts[2] = allParts[2] || '';
  allParts[3] = allParts[3] || '';

  return {
    root: allParts[0],
    dir: allParts[0] + allParts[1].slice(0, -1),
    base: allParts[2],
    ext: allParts[3],
    name: allParts[2].slice(0, allParts[2].length - allParts[3].length)
  };
};


posix.sep = '/';
posix.delimiter = ':';


if (isWindows)
  module.exports = win32;
else /* posix */
  module.exports = posix;

module.exports.posix = posix;
module.exports.win32 = win32;
});
var path_1 = path.posix;
var path_2 = path.win32;

var fs = require('fs');
function modifyDistPath(obj) {
    var root = obj.root, outDir = obj.outDir, html = obj.html, assets = obj.assets;
    return {
        name: 'modifyDistPath',
        closeBundle: function () {
            var fileName = '/index.html';
            /** 转移html文件 */
            fs.mkdir(path.join(root + html), function (err) {
                if (err) {
                    return console.error(err);
                }
                fs.renameSync(path.join(outDir + fileName), path.join(root + html + fileName));
            });
            /** 转移manifest文件 */
            fs.mkdir(path.join(root + assets), function (err) {
                if (err) {
                    return console.error(err);
                }
                fs.renameSync(path.join("".concat(outDir, "/rev-manifest.json")), path.join("".concat(root).concat(assets, "/rev-manifest.json")));
            });
        }
    };
}

var cwd = process.cwd();

var os = require('os');
var fs$1 = require('fs');
var NEWLINE = '\n';
var RE_INI_KEY_VAL = /^\s*([\w.-]+)\s*=\s*("[^"]*"|'[^']*'|.*?)(\s+#.*)?$/;
var RE_NEWLINES = /\\n/g;
var NEWLINES_MATCH = /\r\n|\n|\r/;
var main$1 = { exports: {} };
// Parses src into an Object
function parse(src, options) {
    var debug = Boolean(options && options.debug);
    var multiline = Boolean(options && options.multiline);
    var obj = {};
    // convert Buffers before splitting into lines and processing
    var lines = src.toString().split(NEWLINES_MATCH);
    for (var idx = 0; idx < lines.length; idx++) {
        var line = lines[idx];
        // matching "KEY' and 'VAL' in 'KEY=VAL'
        var keyValueArr = line.match(RE_INI_KEY_VAL);
        // matched?
        if (keyValueArr != null) {
            var key = keyValueArr[1];
            // default undefined or missing values to empty any
            var val = (keyValueArr[2] || '');
            var end = val.length - 1;
            var isDoubleQuoted = val[0] === '"' && val[end] === '"';
            var isSingleQuoted = val[0] === "'" && val[end] === "'";
            var isMultilineDoubleQuoted = val[0] === '"' && val[end] !== '"';
            var isMultilineSingleQuoted = val[0] === "'" && val[end] !== "'";
            // if parsing line breaks and the value starts with a quote
            if (multiline && (isMultilineDoubleQuoted || isMultilineSingleQuoted)) {
                var quoteChar = isMultilineDoubleQuoted ? '"' : "'";
                val = val.substring(1);
                while (idx++ < lines.length - 1) {
                    line = lines[idx];
                    end = line.length - 1;
                    if (line[end] === quoteChar) {
                        val += NEWLINE + line.substring(0, end);
                        break;
                    }
                    val += NEWLINE + line;
                }
                // if single or double quoted, remove quotes
            }
            else if (isSingleQuoted || isDoubleQuoted) {
                val = val.substring(1, end);
                // if double quoted, expand newlines
                if (isDoubleQuoted) {
                    val = val.replace(RE_NEWLINES, NEWLINE);
                }
            }
            else {
                // remove surrounding whitespace
                val = val.trim();
            }
            obj[key] = val;
        }
        else if (debug) {
            var trimmedLine = line.trim();
            // ignore empty and commented lines
            if (trimmedLine.length && trimmedLine[0] !== '#') {
                console.log("Failed to match key and value when parsing line ".concat(idx + 1, ": ").concat(line));
            }
        }
    }
    return obj;
}
function lookupFile(dir, formats, options) {
    for (var _i = 0, formats_1 = formats; _i < formats_1.length; _i++) {
        var format = formats_1[_i];
        var fullPath = path.join(dir, format);
        if (fs$1.existsSync(fullPath) && fs$1.statSync(fullPath).isFile()) {
            var result = (options === null || options === void 0 ? void 0 : options.pathOnly)
                ? fullPath
                : fs$1.readFileSync(fullPath, 'utf-8');
            if (!(options === null || options === void 0 ? void 0 : options.predicate) || options.predicate(result)) {
                return result;
            }
        }
    }
    var parentDir = path.dirname(dir);
    if (parentDir !== dir &&
        (!(options === null || options === void 0 ? void 0 : options.rootDir) || parentDir.startsWith(options === null || options === void 0 ? void 0 : options.rootDir))) {
        return lookupFile(parentDir, formats, options);
    }
}
function resolveHome(envPath) {
    return envPath[0] === '~' ? path.join(os.homedir(), envPath.slice(1)) : envPath;
}
var dotenvExpand = function (config) {
    // if ignoring process.env, use a blank object
    var environment = config.ignoreProcessEnv ? {} : process.env;
    var interpolate = function (envValue) {
        var matches = envValue.match(/(.?\${?(?:[a-zA-Z0-9_]+)?}?)/g) || [];
        return matches.reduce(function (newEnv, match) {
            var parts = /(.?)\${?([a-zA-Z0-9_]+)?}?/g.exec(match);
            var prefix = parts[1];
            var value, replacePart;
            if (prefix === '\\') {
                replacePart = parts[0];
                value = replacePart.replace('\\$', '$');
            }
            else {
                var key = parts[2];
                replacePart = parts[0].substring(prefix.length);
                // process.env value 'wins' over .env file's value
                value = environment.hasOwnProperty(key) ? environment[key] : (config.parsed[key] || '');
                // Resolve recursive interpolations
                value = interpolate(value);
            }
            return newEnv.replace(replacePart, value);
        }, envValue);
    };
    for (var configKey in config.parsed) {
        var value = environment.hasOwnProperty(configKey) ? environment[configKey] : config.parsed[configKey];
        config.parsed[configKey] = interpolate(value);
    }
    for (var processKey in config.parsed) {
        environment[processKey] = config.parsed[processKey];
    }
    return config;
};
var main = dotenvExpand;
// Populates process.env from .env file
function config(options) {
    var dotenvPath = path.resolve(process.cwd(), '.env');
    var encoding = 'utf8';
    var debug = Boolean(options && options.debug);
    var override = Boolean(options && options.override);
    var multiline = Boolean(options && options.multiline);
    if (options) {
        if (options.path != null) {
            dotenvPath = resolveHome(options.path);
        }
        if (options.encoding != null) {
            encoding = options.encoding;
        }
    }
    try {
        // specifying an encoding returns a any instead of a buffer
        var parsed_1 = DotenvModule.parse(fs$1.readFileSync(dotenvPath, { encoding: encoding }), { debug: debug, multiline: multiline });
        Object.keys(parsed_1).forEach(function (key) {
            if (!Object.prototype.hasOwnProperty.call(process.env, key)) {
                process.env[key] = parsed_1[key];
            }
            else {
                if (override === true) {
                    process.env[key] = parsed_1[key];
                }
                if (debug) {
                    if (override === true) {
                        console.log("\"".concat(key, "\" is already defined in `process.env` and WAS overwritten"));
                    }
                    else {
                        console.log("\"".concat(key, "\" is already defined in `process.env` and was NOT overwritten"));
                    }
                }
            }
        });
        return { parsed: parsed_1 };
    }
    catch (e) {
        if (debug) {
            console.log("Failed to load ".concat(dotenvPath, " ").concat(e.message));
        }
        return { error: e };
    }
}
var DotenvModule = {
    config: config,
    parse: parse
};
main$1.exports.config = DotenvModule.config;
main$1.exports.parse = DotenvModule.parse;
main$1.exports = DotenvModule;
function arraify(target) {
    return Array.isArray(target) ? target : [target];
}
var loadEnv = function (mode, envDir, prefixes) {
    var _a;
    if (prefixes === void 0) { prefixes = 'VITE_'; }
    if (mode === 'local') {
        throw new Error("\"local\" cannot be used as a mode name because it conflicts with " +
            "the .local postfix for .env files.");
    }
    var _prefixes = arraify(prefixes);
    var env = {};
    var envFiles = [
        /** mode local file */ ".env.".concat(mode, ".local"),
        /** mode file */ ".env.".concat(mode),
        /** local file */ ".env.local",
        /** default file */ ".env"
    ];
    var _loop_1 = function (key) {
        if (_prefixes.some(function (prefix) { return key.startsWith(prefix); }) &&
            env[key] === undefined) {
            env[key] = process.env[key];
        }
    };
    // check if there are actual env variables starting with VITE_*
    // these are typically provided inline and should be prioritized
    for (var key in process.env) {
        _loop_1(key);
    }
    for (var _i = 0, envFiles_1 = envFiles; _i < envFiles_1.length; _i++) {
        var file = envFiles_1[_i];
        var path_1 = lookupFile(envDir, [file], { pathOnly: true, rootDir: envDir });
        if (path_1) {
            var parsed = main$1.exports.parse(fs$1.readFileSync(path_1), {
                debug: ((_a = process.env.DEBUG) === null || _a === void 0 ? void 0 : _a.includes('vite:dotenv')) || undefined
            });
            // let environment variables use each other
            main({
                parsed: parsed,
                // prevent process.env mutation
                ignoreProcessEnv: true
            });
            var _loop_2 = function (key, value) {
                if (_prefixes.some(function (prefix) { return key.startsWith(prefix); }) &&
                    env[key] === undefined) {
                    env[key] = value;
                }
                else if (key === 'NODE_ENV' &&
                    process.env.VITE_USER_NODE_ENV === undefined) {
                    // NODE_ENV override in .env file
                    process.env.VITE_USER_NODE_ENV = value;
                }
            };
            // only keys that start with prefix are exposed to client
            for (var _b = 0, _c = Object.entries(parsed); _b < _c.length; _b++) {
                var _d = _c[_b], key = _d[0], value = _d[1];
                _loop_2(key, value);
            }
        }
    }
    return env;
};

var IMAGES_REGEXP = ['png', 'jpg', 'jpge', 'gif', 'svga'];
var initProject = function (localConfig, viteConfig) {
    var _a, _b, _c, _d, _e, _f;
    /** 基础路径 */
    var BASE_PROJECT_PATH = ((_a = localConfig === null || localConfig === void 0 ? void 0 : localConfig.dest) === null || _a === void 0 ? void 0 : _a.basePath) || './';
    /** css文件路径 */
    var CSS_PATH = ((_b = localConfig === null || localConfig === void 0 ? void 0 : localConfig.dest) === null || _b === void 0 ? void 0 : _b.cssPath) || 'css';
    /** js文件路径 */
    var JS_PATH = ((_c = localConfig === null || localConfig === void 0 ? void 0 : localConfig.dest) === null || _c === void 0 ? void 0 : _c.jsPath) || 'js';
    /** html文件路径 */
    var HTML_PATH = ((_d = localConfig === null || localConfig === void 0 ? void 0 : localConfig.dest) === null || _d === void 0 ? void 0 : _d.htmlPath) || 'html';
    /** 图片文件路径 */
    var IMG_PATH = ((_e = localConfig === null || localConfig === void 0 ? void 0 : localConfig.dest) === null || _e === void 0 ? void 0 : _e.imagesPath) || 'images';
    /** alias 基础路径 */
    var ALIAS_ROOT_PATH = (localConfig === null || localConfig === void 0 ? void 0 : localConfig.alias).srcRoot || './src/';
    /** 输出目录 */
    var OUTDIR_PATH = (localConfig === null || localConfig === void 0 ? void 0 : localConfig.outDir) || './dist/';
    var config = {
        /** 根目录 */
        root: localConfig.root || './',
        // /** 存储缓存文件的目录。 */
        cacheDir: localConfig.cacheDir || 'node_modules/.vite',
        clearScreen: localConfig.clearScreen || false,
        /** 出口文件 */
        build: {
            outDir: path.join(cwd, OUTDIR_PATH),
            emptyOutDir: true,
            manifest: 'rev-manifest.json',
            assetsInlineLimit: 4096,
            rollupOptions: {
                external: ['react', 'react-dom'],
                output: {
                    entryFileNames: BASE_PROJECT_PATH + 'js/[name]-[hash].js',
                    assetFileNames: function (val) {
                        var _a;
                        var works = (_a = val.name) === null || _a === void 0 ? void 0 : _a.split('.');
                        if (works) {
                            var type = works[works.length - 1];
                            if (type === 'css') {
                                return BASE_PROJECT_PATH + CSS_PATH + '/[name]-[hash].[ext]';
                            }
                            if (type === 'js') {
                                return BASE_PROJECT_PATH + JS_PATH + '/[name]-[hash].[ext]';
                            }
                            if (IMAGES_REGEXP.includes(type)) {
                                return BASE_PROJECT_PATH + IMG_PATH + '/[name]-[hash].[ext]';
                            }
                        }
                        var ext = 'assets';
                        return BASE_PROJECT_PATH + ext + '/[name]-[hash].[ext]';
                    },
                    globals: {
                        react: 'react',
                        'react-dom': 'react-dom'
                    }
                }
            }
        },
        /** 开发配置 */
        server: {
            host: '0.0.0.0',
            port: ((_f = localConfig.server) === null || _f === void 0 ? void 0 : _f.port) || 5000
        },
        /** 路径设置 */
        resolve: {
            alias: Array.isArray(localConfig === null || localConfig === void 0 ? void 0 : localConfig.alias)
                ? localConfig.alias
                : [
                    {
                        find: '~@',
                        replacement: path.join(ALIAS_ROOT_PATH + 'components/')
                    },
                    {
                        find: '~',
                        replacement: path.join(ALIAS_ROOT_PATH)
                    }
                ]
        },
        /** 导入 .css 文件将会把内容插入到 <style> 标签中，同时也带有 HMR 支持。也能够以字符串的形式检索处理后的、作为其模块默认导出的 CSS。 */
        css: {
            modules: localConfig.cssModules
                ? {
                    // css模块化 文件以.module.[css|less|scss]结尾
                    generateScopedName: '[name]__[local]___[hash:base64:5]',
                    hashPrefix: 'winkey'
                }
                : false,
            /** 指定传递给 CSS 预处理器的选项。文件扩展名用作选项的键 */
            preprocessorOptions: {
                less: {
                    /** 支持内敛JavaScript */
                    javascriptEnabled: true
                },
                scss: {
                    /** 支持内敛JavaScript */
                    javascriptEnabled: true
                }
            }
        },
        /** 插件 */
        plugins: [
            legacy({
                targets: ['Android >= 39', 'Chrome >= 39', 'Safari >= 10.1', 'iOS >= 10', '> 0.5%'],
                polyfills: ['es.promise', 'regenerator-runtime']
            }),
            eslintPlugin({
                include: ['src/**/*.ts', 'src/**/*.tsx', 'src/*.ts', 'src/*.tsx']
            }),
            modifyDistPath({
                root: OUTDIR_PATH + BASE_PROJECT_PATH,
                outDir: OUTDIR_PATH,
                html: HTML_PATH,
                assets: '/assets'
            }),
            react(),
            tsconfigPaths(),
            StylelintPlugin({
                fix: true,
                quiet: true
            }),
            qiankun('react18', {
                useDevMode: true
            })
        ]
    };
    /** 合并plugin */
    config.plugins = Object.assign(config.plugins, localConfig.plugins || []);
    /** 合并css */
    config.css = Object.assign(config.css, localConfig.css || {});
    var _g = viteConfig, mode = _g.mode, command = _g.command;
    var env = loadEnv(mode, process.cwd());
    var isBuild = command === 'build';
    config.plugins = __spreadArray(__spreadArray([], config.plugins, true), [
        vitePluginHtml.createHtmlPlugin({
            inject: {
                data: __assign(__assign({}, env), { devServerToolScript: localConfig.winkeyTool && !isBuild
                        ? "<script type=\"module\" src=\"/winkey_tool/js/index.js\"></script>"
                        : '', devServerToolDom: localConfig.winkeyTool && !isBuild
                        ? "<div id=\"winkey_tool\"></div>"
                        : '', devServerToolCss: localConfig.winkeyTool && !isBuild
                        ? "<link href=\"/winkey_tool/css/index.css\" rel=\"stylesheet\" >"
                        : '' })
            }
        })
    ], false);
    return config;
};

var initComponent = function (localConfig, viteConfig) {
    var _a;
    /** 包名 */
    var pkgName = localConfig.name || 'demo';
    /** alias 基础路径 */
    var ALIAS_ROOT_PATH = (localConfig === null || localConfig === void 0 ? void 0 : localConfig.alias).srcRoot || './src/';
    /** 输出目录 */
    var OUTDIR_PATH = (localConfig === null || localConfig === void 0 ? void 0 : localConfig.outDir) || './dist/';
    var config = {
        base: '/',
        /** 根目录 */
        root: localConfig.root || './',
        // /** 存储缓存文件的目录。 */
        cacheDir: localConfig.cacheDir || 'node_modules/.vite',
        clearScreen: localConfig.clearScreen || false,
        /** 出口文件 */
        build: {
            lib: {
                entry: path.resolve(cwd, 'src/components/index.tsx'),
                name: pkgName,
                fileName: pkgName
            },
            cssTarget: 'chrome61',
            outDir: 'dist',
            rollupOptions: {
                // 确保外部化处理那些你不想打包进库的依赖
                external: ['react', 'react-dom'],
                output: {
                    // 在 UMD 构建模式下为这些外部化的依赖提供一个全局变量
                    globals: {
                        react: 'react',
                        'react-dom': 'react-dom'
                    }
                }
            }
        },
        /** 开发配置 */
        server: {
            host: '0.0.0.0',
            port: ((_a = localConfig.server) === null || _a === void 0 ? void 0 : _a.port) || 5000
        },
        /** 路径设置 */
        resolve: {
            alias: Array.isArray(localConfig === null || localConfig === void 0 ? void 0 : localConfig.alias)
                ? localConfig.alias
                : [
                    {
                        find: '~@',
                        replacement: path.join(ALIAS_ROOT_PATH + 'components/')
                    },
                    {
                        find: '~',
                        replacement: path.join(ALIAS_ROOT_PATH)
                    }
                ]
        },
        /** 导入 .css 文件将会把内容插入到 <style> 标签中，同时也带有 HMR 支持。也能够以字符串的形式检索处理后的、作为其模块默认导出的 CSS。 */
        css: {
            modules: localConfig.cssModules
                ? {
                    // css模块化 文件以.module.[css|less|scss]结尾
                    generateScopedName: '[name]__[local]___[hash:base64:5]',
                    hashPrefix: 'winkey'
                }
                : false,
            /** 指定传递给 CSS 预处理器的选项。文件扩展名用作选项的键 */
            preprocessorOptions: {
                less: {
                    /** 支持内敛JavaScript */
                    javascriptEnabled: true
                },
                scss: {
                    /** 支持内敛JavaScript */
                    javascriptEnabled: true
                }
            }
        },
        /** 插件 */
        plugins: [
            eslintPlugin({
                include: ['src/**/*.ts', 'src/**/*.tsx', 'src/*.ts', 'src/*.tsx']
            }),
            react(),
            tsconfigPaths(),
            StylelintPlugin({
                fix: true,
                quiet: true
            }),
        ]
    };
    /** 合并plugin */
    config.plugins = Object.assign(config.plugins, localConfig.plugins || []);
    /** 合并css */
    config.css = Object.assign(config.css, localConfig.css || {});
    var _b = viteConfig, mode = _b.mode, command = _b.command;
    var env = loadEnv(mode, process.cwd());
    var isBuild = command === 'build';
    if (isBuild) {
        // 压缩 Html 插件
        config.define = {
            'process.env.NODE_ENV': '"production"'
        };
        config.plugins = __spreadArray(__spreadArray([], config.plugins, true), [
            typescript({
                target: 'es5',
                rootDir: path.resolve(cwd, 'src/components'),
                declaration: true,
                declarationDir: path.resolve(cwd, 'dist'),
                exclude: [path.resolve('node_modules/**'), path.resolve('winkey.config.ts')],
                allowSyntheticDefaultImports: true
            })
        ], false);
    }
    config.plugins = __spreadArray(__spreadArray([], config.plugins, true), [
        vitePluginHtml.createHtmlPlugin({
            inject: {
                data: __assign(__assign({}, env), { devServerToolScript: localConfig.winkeyTool && !isBuild
                        ? "<script type=\"module\" src=\"/winkey_tool/js/index.js\"></script>"
                        : '', devServerToolDom: localConfig.winkeyTool && !isBuild
                        ? "<div id=\"winkey_tool\"></div>"
                        : '', devServerToolCss: localConfig.winkeyTool && !isBuild
                        ? "<link href=\"/winkey_tool/css/index.css\" rel=\"stylesheet\" >"
                        : '' })
            }
        })
    ], false);
    return config;
};

var initWinkeyConfig = function (winkeyConfig, viteConfig) {
    var localConfig = winkeyConfig;
    if (localConfig.component) {
        return initComponent(winkeyConfig, viteConfig);
    }
    return initProject(winkeyConfig, viteConfig);
};

exports.initWinkeyConfig = initWinkeyConfig;
